/* myTimer -- the timing object for doing lsystem graph-interpretation
	using RTcmix WAVETABLE instrument.  "myTimer.C" is
	the animator object (can't use RTtimeit because of graphics
	context problems)  -- BGG/2003
*/
#include "wx/wxprec.h"

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "myTimer.h"
#include <iostream.h>



myTimer::myTimer(wxClientDC *thedc, RTcmix *rt)
{
	wdc = thedc;
	rrr = rt;
}

void myTimer::setX(int startx)
{
	x = startx;
}

void myTimer::Notify()
{
// check for red pixels across the line here, and translate position
// directly into frequency (invert because the windows goes positive down)
	int i;
	int noscs;
	wxColour check;

	noscs = 0;
	for (i = 0; i < 500; i++)
	{
		wdc->GetPixel(x, i, &check);
		if (check.Blue() == 0)
		{
			if (noscs < 15)
			{
			// schedule a new note for every 'red' (non-blue)
			// encountered -- 0.2 seconds long for 0.1 check-timing
			rrr->cmd("WAVETABLE", 5, 0.0, 0.2, 500.0, (float)(700-i), 0.5);
			noscs++;
			}
		}
	}

	// the "LogicalFunction" operation allows us to erase the previous
	// line and retain the l-system already graphed on the window
	wdc->SetPen(*wxGREEN_PEN);
	wdc->SetLogicalFunction(wxINVERT);
	wdc->DrawLine(x,0, x, 500);

	// erase the previous line
	if (x > 0) wdc->DrawLine(x-1,0, x-1, 500);

	x++;
	if (x > 1000) Stop();
}
